## 后端代码生成
后端大部分指令可以采用与中端类似的方法完成，比如中端的Binary.add 
对应 ARM 和 Riscv的后端add指令等。做出特殊处理的主要有几点：
### 算术优化
- 乘法优化
  - 对于常数乘以寄存器类型的指令，我们进行了优化处理。将立即数操作数进行了分解。
  我们认为如果乘数可以被分解为两个以内2^i之差或之和，那么他就可以被拆解为两条以内
  移位指令之积或者之和。
- 除法优化
  - 当被除数为常数时，我们进行了多类除法优化，对于除数为2的幂次的情况
  我们直接转换为移位指令，对于其他情况，我们借助论文《Division by Invariant Integers using Multiplication》的方法
  将除法转换为多条乘法以及移位指令。
### 分支指令生成
后端指令生成的一个难点在于分支指令，原因是中端与后端分支指令处理的不一致。

对于中端，分支指令往往表现为ICMP（FCMP）后接一条Branch，但经过优化之后，两条指令会出现不连续现象。
而对于后端，在ARM中，引入了条件码，需要两者之间连续，或者中间只有mov等不影响条件码的语句。对于Riscv
理想情况下则是使用blt、bge、beq、bne直接进行处理。

值得一提的是，在本次中端优化之后，还会有不符合SSA形式的MOVE指令，穿插在
比较指令与分支指令之间，所以我们采用了比较指令先利用RV的slt指令以及
ARM的条件赋值指令赋值，然后parse分支指令时再取出该值进行比较的方式，
然后再在最后的窥孔时，根据指令情况决定是否合并为理想情况。